#region Using declarations
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.ComponentModel.DataAnnotations;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Input;
using System.Windows.Media;
using System.Xml.Serialization;
using NinjaTrader.Cbi;
using NinjaTrader.Gui;
using NinjaTrader.Gui.Chart;
using NinjaTrader.Gui.SuperDom;
using NinjaTrader.Gui.Tools;
using NinjaTrader.Data;
using NinjaTrader.NinjaScript;
using NinjaTrader.Core.FloatingPoint;

#endregion



#region NinjaScript generated code. Neither change nor remove.

namespace NinjaTrader.NinjaScript.Indicators
{
	public partial class Indicator : NinjaTrader.Gui.NinjaScript.IndicatorRenderBase
	{
		
		private NeoTraderBot_Indicators.NTBCumulativeDelta[] cacheNTBCumulativeDelta;
		private NeoTraderBot_Indicators.NTBDeltaTrend[] cacheNTBDeltaTrend;
		private NeoTraderBot_Indicators.NTBDeltaVolume[] cacheNTBDeltaVolume;
		private NeoTraderBot_Indicators.NTBWeisWave[] cacheNTBWeisWave;

		
		public NeoTraderBot_Indicators.NTBCumulativeDelta NTBCumulativeDelta(NTBCumDeltaType deltaType)
		{
			return NTBCumulativeDelta(Input, deltaType);
		}

		public NeoTraderBot_Indicators.NTBDeltaTrend NTBDeltaTrend(NTBCumulativeTrendMode trendMode)
		{
			return NTBDeltaTrend(Input, trendMode);
		}

		public NeoTraderBot_Indicators.NTBDeltaVolume NTBDeltaVolume(DeltaVolumeMode mode)
		{
			return NTBDeltaVolume(Input, mode);
		}

		public NeoTraderBot_Indicators.NTBWeisWave NTBWeisWave(DeviationType deviation, double deviationValue, bool useHighLow)
		{
			return NTBWeisWave(Input, deviation, deviationValue, useHighLow);
		}


		
		public NeoTraderBot_Indicators.NTBCumulativeDelta NTBCumulativeDelta(ISeries<double> input, NTBCumDeltaType deltaType)
		{
			if (cacheNTBCumulativeDelta != null)
				for (int idx = 0; idx < cacheNTBCumulativeDelta.Length; idx++)
					if (cacheNTBCumulativeDelta[idx].deltaType == deltaType && cacheNTBCumulativeDelta[idx].EqualsInput(input))
						return cacheNTBCumulativeDelta[idx];
			return CacheIndicator<NeoTraderBot_Indicators.NTBCumulativeDelta>(new NeoTraderBot_Indicators.NTBCumulativeDelta(){ deltaType = deltaType }, input, ref cacheNTBCumulativeDelta);
		}

		public NeoTraderBot_Indicators.NTBDeltaTrend NTBDeltaTrend(ISeries<double> input, NTBCumulativeTrendMode trendMode)
		{
			if (cacheNTBDeltaTrend != null)
				for (int idx = 0; idx < cacheNTBDeltaTrend.Length; idx++)
					if (cacheNTBDeltaTrend[idx].trendMode == trendMode && cacheNTBDeltaTrend[idx].EqualsInput(input))
						return cacheNTBDeltaTrend[idx];
			return CacheIndicator<NeoTraderBot_Indicators.NTBDeltaTrend>(new NeoTraderBot_Indicators.NTBDeltaTrend(){ trendMode = trendMode }, input, ref cacheNTBDeltaTrend);
		}

		public NeoTraderBot_Indicators.NTBDeltaVolume NTBDeltaVolume(ISeries<double> input, DeltaVolumeMode mode)
		{
			if (cacheNTBDeltaVolume != null)
				for (int idx = 0; idx < cacheNTBDeltaVolume.Length; idx++)
					if (cacheNTBDeltaVolume[idx].mode == mode && cacheNTBDeltaVolume[idx].EqualsInput(input))
						return cacheNTBDeltaVolume[idx];
			return CacheIndicator<NeoTraderBot_Indicators.NTBDeltaVolume>(new NeoTraderBot_Indicators.NTBDeltaVolume(){ mode = mode }, input, ref cacheNTBDeltaVolume);
		}

		public NeoTraderBot_Indicators.NTBWeisWave NTBWeisWave(ISeries<double> input, DeviationType deviation, double deviationValue, bool useHighLow)
		{
			if (cacheNTBWeisWave != null)
				for (int idx = 0; idx < cacheNTBWeisWave.Length; idx++)
					if (cacheNTBWeisWave[idx].deviation == deviation && cacheNTBWeisWave[idx].deviationValue == deviationValue && cacheNTBWeisWave[idx].useHighLow == useHighLow && cacheNTBWeisWave[idx].EqualsInput(input))
						return cacheNTBWeisWave[idx];
			return CacheIndicator<NeoTraderBot_Indicators.NTBWeisWave>(new NeoTraderBot_Indicators.NTBWeisWave(){ deviation = deviation, deviationValue = deviationValue, useHighLow = useHighLow }, input, ref cacheNTBWeisWave);
		}

	}
}

namespace NinjaTrader.NinjaScript.MarketAnalyzerColumns
{
	public partial class MarketAnalyzerColumn : MarketAnalyzerColumnBase
	{
		
		public Indicators.NeoTraderBot_Indicators.NTBCumulativeDelta NTBCumulativeDelta(NTBCumDeltaType deltaType)
		{
			return indicator.NTBCumulativeDelta(Input, deltaType);
		}

		public Indicators.NeoTraderBot_Indicators.NTBDeltaTrend NTBDeltaTrend(NTBCumulativeTrendMode trendMode)
		{
			return indicator.NTBDeltaTrend(Input, trendMode);
		}

		public Indicators.NeoTraderBot_Indicators.NTBDeltaVolume NTBDeltaVolume(DeltaVolumeMode mode)
		{
			return indicator.NTBDeltaVolume(Input, mode);
		}

		public Indicators.NeoTraderBot_Indicators.NTBWeisWave NTBWeisWave(DeviationType deviation, double deviationValue, bool useHighLow)
		{
			return indicator.NTBWeisWave(Input, deviation, deviationValue, useHighLow);
		}


		
		public Indicators.NeoTraderBot_Indicators.NTBCumulativeDelta NTBCumulativeDelta(ISeries<double> input , NTBCumDeltaType deltaType)
		{
			return indicator.NTBCumulativeDelta(input, deltaType);
		}

		public Indicators.NeoTraderBot_Indicators.NTBDeltaTrend NTBDeltaTrend(ISeries<double> input , NTBCumulativeTrendMode trendMode)
		{
			return indicator.NTBDeltaTrend(input, trendMode);
		}

		public Indicators.NeoTraderBot_Indicators.NTBDeltaVolume NTBDeltaVolume(ISeries<double> input , DeltaVolumeMode mode)
		{
			return indicator.NTBDeltaVolume(input, mode);
		}

		public Indicators.NeoTraderBot_Indicators.NTBWeisWave NTBWeisWave(ISeries<double> input , DeviationType deviation, double deviationValue, bool useHighLow)
		{
			return indicator.NTBWeisWave(input, deviation, deviationValue, useHighLow);
		}
	
	}
}

namespace NinjaTrader.NinjaScript.Strategies
{
	public partial class Strategy : NinjaTrader.Gui.NinjaScript.StrategyRenderBase
	{
		
		public Indicators.NeoTraderBot_Indicators.NTBCumulativeDelta NTBCumulativeDelta(NTBCumDeltaType deltaType)
		{
			return indicator.NTBCumulativeDelta(Input, deltaType);
		}

		public Indicators.NeoTraderBot_Indicators.NTBDeltaTrend NTBDeltaTrend(NTBCumulativeTrendMode trendMode)
		{
			return indicator.NTBDeltaTrend(Input, trendMode);
		}

		public Indicators.NeoTraderBot_Indicators.NTBDeltaVolume NTBDeltaVolume(DeltaVolumeMode mode)
		{
			return indicator.NTBDeltaVolume(Input, mode);
		}

		public Indicators.NeoTraderBot_Indicators.NTBWeisWave NTBWeisWave(DeviationType deviation, double deviationValue, bool useHighLow)
		{
			return indicator.NTBWeisWave(Input, deviation, deviationValue, useHighLow);
		}


		
		public Indicators.NeoTraderBot_Indicators.NTBCumulativeDelta NTBCumulativeDelta(ISeries<double> input , NTBCumDeltaType deltaType)
		{
			return indicator.NTBCumulativeDelta(input, deltaType);
		}

		public Indicators.NeoTraderBot_Indicators.NTBDeltaTrend NTBDeltaTrend(ISeries<double> input , NTBCumulativeTrendMode trendMode)
		{
			return indicator.NTBDeltaTrend(input, trendMode);
		}

		public Indicators.NeoTraderBot_Indicators.NTBDeltaVolume NTBDeltaVolume(ISeries<double> input , DeltaVolumeMode mode)
		{
			return indicator.NTBDeltaVolume(input, mode);
		}

		public Indicators.NeoTraderBot_Indicators.NTBWeisWave NTBWeisWave(ISeries<double> input , DeviationType deviation, double deviationValue, bool useHighLow)
		{
			return indicator.NTBWeisWave(input, deviation, deviationValue, useHighLow);
		}

	}
}

#endregion
